package kr.nerv.controller;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kr.nerv.command.ResultCommand;
import kr.nerv.service.UserService;
import kr.nerv.vo.UserInfoVo;

import org.springframework.validation.BindException;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractCommandController;

public class ResultController extends AbstractCommandController {
	// service
	private UserService userService;

	@Override
	protected ModelAndView handle(HttpServletRequest request, HttpServletResponse response,
			Object obj, BindException errors) throws Exception {
		// view
		ModelAndView mav = new ModelAndView("user/result");
		// command
		ResultCommand command = (ResultCommand) obj;
		
		String message = "정상적으로 조회되었습니다.";
		
		try {
			UserInfoVo userInfo = userService.getUser(command.getId());
			// add user info to view
			mav.addObject("userInfo", userInfo);
		} catch (Exception e) {
			// e.printStackTrace();
			message = e.getMessage();
		}
		
		// add message to view
		mav.addObject("message", message);
		
		return mav;
	}

	public void setUserService(UserService userService) {
		this.userService = userService;
	}

}
