package kr.nerv.dao.impl;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcDaoSupport;

import kr.nerv.dao.UserInfoDao;
import kr.nerv.vo.UserInfoVo;

public class UserInfoDaoJdbc extends NamedParameterJdbcDaoSupport implements UserInfoDao {
	// row mapper
	private UserInfoRowMapper rowMapper = new UserInfoRowMapper();
	// find by id query
	private String findById = "select * from sample_user_info where id = :id";

	@Override
	public UserInfoVo findById(Integer id) throws Exception {
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("id", id);

		try {
			return (UserInfoVo) getNamedParameterJdbcTemplate().queryForObject(findById, param,
					rowMapper);
		} catch (EmptyResultDataAccessException e) {
			return null;
		}

	}

	private class UserInfoRowMapper implements RowMapper {
		@Override
		public UserInfoVo mapRow(ResultSet rs, int rowNum) throws SQLException {
			UserInfoVo userInfo = new UserInfoVo();
			userInfo.setId(rs.getInt("id"));
			userInfo.setName(rs.getString("name"));
			userInfo.setTel(rs.getString("tel"));

			return userInfo;
		}

	}
}
